<?php

global $sgrb;
$sgrb->includeModel('Model');
define('SGRB_IMAGES_PATH', $sgrb->asset('page/img/'));

class SGRB_TemplateDesignModel extends SGRB_Model
{
	const TABLE = 'template_design';
	protected $id;
	protected $name;
	protected $sgrb_pro_version;
	protected $img_url;
	protected $thtml;
	protected $tcss;

	public static function finder($class = __CLASS__)
	{
		return parent::finder($class);
	}

	public static function create($blogId = '')
	{
		global $sgrb;
		global $wpdb;
		$saveTemplates = get_option('saveTemplates');
		$tablename = $sgrb->tablename(self::TABLE, $blogId);
		$path = $sgrb->app_url.'assets/page/img/';

		$dropQquery = "DROP TABLE IF EXISTS $tablename";
		$createQuery = "CREATE TABLE $tablename (
					  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
					  `name` varchar(255) NOT NULL,
					  `sgrb_pro_version` tinyint(3) unsigned DEFAULT NULL,
					  `img_url` varchar(255) NOT NULL,
					  `thtml` longtext NOT NULL,
					  `tcss` longtext NOT NULL,
					  PRIMARY KEY (`id`)
					) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;";

		if (!$saveTemplates) {
			$wpdb->query($dropQquery);
			$wpdb->query($createQuery);
		}

		$insertQuery1 = "INSERT INTO $tablename VALUES (1,'full_box',1,'".$path."full_box.jpeg','<div class=\"sg-template-wrapper\">\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-6\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n</div>\r\n<div class=\"sg-col-6\">\r\n<div class=\"sg-tempo-title\">[sgrbtitle]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrbsubtitle]</div>\r\n<div class=\"sg-tempo-title-info sg-temp-field-full-height\">[sgrbshortdescription]</div>\r\n</div>\r\n</div>\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-12\">\r\n<div class=\"sg-tempo-context\">[sgrblongdescription]</div>\r\n</div>\r\n</div>\r\n</div>','.sg-template-wrapper {\r\n	width: 100%;\r\n	height: 100%;\r\n	padding: 10px;\r\n	border: 1px solid #eeeeee;\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-template-box {\r\n	display: inline-block;\r\n	min-height: 30px;\r\n	width: 100%;\r\n	margin-bottom: 30px;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-context {\r\n	width: 100%;\r\n	min-height: 20px;\r\n	display: inline-block;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	border-radius: 5px;\r\n	background-color: rgb(254, 254, 254);\r\n	box-sizing: border-box;\r\n	margin-top: 10px;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-image {\r\n	max-width: 500px;\r\n	overflow: hidden;\r\n	height: 300px;\r\n}\r\n\r\n.sg-tempo-title {\r\n	width: 100%;\r\n	display: inline-block;\r\n	border: 1px solid rgb(223, 223, 223);\r\n	border-radius: 5px;\r\n	font-size: 1.4em;\r\n    font-weight: bold;\r\n	background-color: white;\r\n	text-align: center;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-title-second {\r\n	width: 100%;\r\n	min-height: 34px;\r\n	display: inline-block;\r\n	margin: 5px 0;\r\n	padding: 0 5px;\r\n	border: 1px solid rgb(223, 223, 223);\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 140%;\r\n}\r\n\r\n.sg-tempo-title-info {\r\n	width: 100%;\r\n	/*height: 180px;*/\r\n	display: inline-block;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	border-radius: 5px;\r\n	background-color: white;\r\n	padding: 5px;\r\n	box-sizing: border-box;\r\n	line-height: 120%;\r\n	overflow: hidden;\r\n}\r\n\r\n.sgrb-icon-wrapper {\r\n	left: 35% !important;\r\n	top: 35% !important;\r\n}\r\n');";
		$insertQuery2 = "INSERT INTO $tablename VALUES (2,'full_width',1,'".$path."full_width.jpeg','<div class=\"sg-template-wrapper\">\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-12\">\r\n<div class=\"sg-tempo-title\">[sgrbtitle]</div>\r\n</div>\r\n</div>\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-12\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n</div>\r\n</div>\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-12\">\r\n<div class=\"sg-tempo-context\">[sgrblongdescription]</div>\r\n</div>\r\n</div>\r\n</div>\r\n','.sg-template-wrapper {\r\n	width: 100%;\r\n	padding: 10px;\r\n	border: 1px solid #eeeeee;\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-title {\r\n	width: 100%;\r\n	display: inline-block;\r\n	border: 1px solid rgb(223, 223, 223);\r\n	border-radius: 5px;\r\n	font-size: 1.4em;\r\n	font-weight: bold;\r\n	background-color: white;\r\n	text-align: center;\r\n	box-sizing:border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-image {\r\n	width: 100%;\r\n	overflow: hidden;\r\n	margin: 30px auto;\r\n	height: 300px;\r\n	max-width: 500px;\r\n}\r\n\r\n.sg-tempo-context {\r\n	width: 100%;\r\n	min-height: 20px;\r\n	display: inline-block;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	background-color: rgb(254, 254, 254);\r\n	box-sizing:border-box;\r\n	padding: 10px;\r\n	overflow: hidden;\r\n}\r\n\r\n.sgrb-icon-wrapper {\r\n	left: 37% !important;\r\n	top: 40% !important;\r\n}\r\n')";
		$insertQuery3 = "INSERT INTO $tablename VALUES (3,'img_left',1,'".$path."img_left.jpeg','<div class=\"sg-template-wrapper\">\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-6\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n</div>\r\n\r\n<div class=\"sg-col-6\">\r\n<div class=\"sg-tempo-title\">[sgrbtitle]</div>\r\n<div class=\"sg-tempo-title-second sg-temp-field-full-height\">[sgrbsubtitle]</div>\r\n<div class=\"sg-tempo-title-second sg-temp-field-full-height\">[sgrbsubtitle]</div>\r\n<div class=\"sg-tempo-title-second sg-temp-field-full-height\">[sgrbsubtitle]</div>\r\n<div class=\"sg-tempo-title-info sg-temp-field-full-height\">[sgrblongdescription]</div>\r\n</div>\r\n</div>\r\n</div>','.sg-template-wrapper {\r\n	width: 100%;\r\n	height: 100%;\r\n	padding: 10px;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-image {\r\n	max-width: 500px;\r\n	overflow: hidden;\r\n	height: 390px;\r\n}\r\n\r\n.sg-tempo-title {\r\n	width: 100%;\r\n	display: inline-block;\r\n	margin-bottom: 10px;\r\n	border-radius: 3px;\r\n	font-size: 1.4em;\r\n	font-weight: bold;\r\n	background-color: white;\r\n	text-align: center;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-title-second {\r\n	width: 100%;\r\n	height: 30px;\r\n	display: inline-block;\r\n	margin-bottom: 10px;\r\n	padding: 0 5px;\r\n	border-radius: 3px;\r\n	font-size: 1.2em;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-title-info {\r\n	width: 100%;\r\n	height: 180px;\r\n	display: inline-block;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	line-height: 140%;\r\n	overflow: hidden;\r\n}\r\n.sgrb-icon-wrapper {\r\n	left: 35% !important;\r\n	top: 35% !important;\r\n}\r\n');";
		$insertQuery4 = "INSERT INTO $tablename VALUES (4,'img_right',1,'".$path."img_right.jpeg','<div class=\"sg-template-wrapper\">\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-6\">\r\n<div class=\"sg-tempo-title\">[sgrbtitle]</div>\r\n<div class=\"sg-tempo-title-second sg-temp-field-full-height\">[sgrbshortdescription]</div>\r\n<div class=\"sg-tempo-title-info sg-temp-field-full-height\">[sgrblongdescription]</div>\r\n</div>\r\n\r\n<div class=\"sg-col-6\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n</div>\r\n</div>\r\n</div>','.sg-template-wrapper {\r\n	width: 100%;\r\n	height: 100%;\r\n	padding: 10px;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-template-box {\r\n	display: inline-block;\r\n	min-height: 30px;\r\n	width: 100%;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-image {\r\n	max-width: 500px;\r\n	overflow: hidden;\r\n	height: 390px;\r\n}\r\n\r\n.sg-tempo-title {\r\n	width: 100%;\r\n	display: inline-block;\r\n	margin-bottom: 10px;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	border-radius: 3px;\r\n	font-size: 1.4em;\r\n	font-weight: bold;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-title-second {\r\n	width: 100%;\r\n	height: 120px;\r\n	display: inline-block;\r\n	margin-bottom: 10px;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	border-radius: 3px;\r\n	font-size: 1.1em;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-title-info {\r\n	width: 100%;\r\n	height: 200px;\r\n	display: inline-block;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	line-height: 150%;\r\n	overflow: hidden;\r\n}\r\n.sgrb-icon-wrapper {\r\n	left: 35% !important;\r\n	top: 35% !important;\r\n}\r\n');";
		$insertQuery5 = "INSERT INTO $tablename VALUES (5,'short_box',1,'".$path."short_box.jpeg','<div class=\"sg-template-wrapper\">\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-12\">\r\n<div class=\"sg-tempo-title\">[sgrbtitle]</div>\r\n</div>\r\n</div>\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-6\">\r\n<div class=\"sg-tempo-title-second sg-temp-field-full-height\">[sgrbsubtitle]</div>\r\n<div class=\"sg-tempo-title-info sg-temp-field-full-height\">[sgrbshortdescription]</div>\r\n</div>\r\n<div class=\"sg-col-6\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n</div>\r\n</div>\r\n</div>','.sg-template-wrapper {\r\n	width: 100%;\r\n	height: 100%;\r\n	padding: 10px;\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-template-box {\r\n	display: inline-block;\r\n	min-height: 30px;\r\n	width: 100%;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-image {\r\n	max-width: 500px;\r\n	overflow: hidden;\r\n	height: 270px;\r\n}\r\n\r\n.sg-tempo-title {\r\n	width: 100%;\r\n	display: inline-block;\r\n	margin-bottom: 10px;\r\n	border: 1px solid rgb(223, 223, 223);\r\n	border-radius: 3px;\r\n	text-align: center;\r\n	font-size: 1.4em;\r\n	font-weight: bold;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-title-second {\r\n	width: 100%;\r\n	height: 80px;\r\n	display: inline-block;\r\n	margin-bottom: 10px;\r\n	padding: 0 5px;\r\n	border: 1px solid rgb(223, 223, 223);\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	line-height: 120%;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-title-info {\r\n	width: 100%;\r\n	height: 180px;\r\n	display: inline-block;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	line-height: 120%;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n}\r\n\r\n.sgrb-icon-wrapper {\r\n	left: 35% !important;\r\n	top: 35% !important;\r\n}\r\n')";
		$insertQuery7 = "INSERT INTO $tablename VALUES (7,'left_image_double_link',1,'".$path."template_2.jpeg','<div class=\"sg-template-wrapper\">\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-4\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n</div>\r\n<div class=\"sg-col-8\">\r\n<div class=\"sg-tempo-title\">[sgrbtitle]</div>\r\n<div class=\"sg-tempo-price\">[sgrbprice]</div>\r\n<div class=\"sg-tempo-shipping\">[sgrbshipping]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-title-info sg-temp-field-full-height\">[sgrbshortdescription]</div>\r\n<div class=\"sg-tempo-by\">[sgrbproductby]</div>\r\n</div>\r\n</div>\r\n</div>','.sg-template-wrapper {\r\n	width: 100%;\r\n	height: 100%;\r\n	padding: 10px;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-image {\r\n	max-width: 500px;\r\n	overflow: hidden;\r\n	height: 390px;\r\n}\r\n\r\n.sg-tempo-title {\r\n	width: 100%;\r\n	height: 45px;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	font-size: 1.1em;\r\n	font-weight: bold;\r\n	text-align: center;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-by {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #0066c0;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-price {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #D07D68;\r\n	font-size: 20px;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-shipping {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #000000;\r\n	font-size: 15px;\r\n	font-style: bold;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-title-second {\r\n	width: 100%;\r\n	height: 35px;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-title-info {\r\n	width: 100%;\r\n	height: 180px;\r\n	display: inline-block;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	line-height: 116%;\r\n	overflow: hidden;\r\n}\r\n\r\n.sgrb-icon-wrapper {\r\n	left: 28% !important;\r\n	top: 40% !important;\r\n}\r\n')";
		$insertQuery13 = "INSERT INTO $tablename VALUES (13,'top_bottom_image',1,'".$path."template_8.jpeg','<div class=\"sg-template-wrapper\">\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-12\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n</div>\r\n</div>\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-12\">\r\n<div class=\"sg-tempo-title\">[sgrbtitle]</div>\r\n<div class=\"sg-tempo-price\">[sgrbprice]</div>\r\n<div class=\"sg-tempo-shipping\">[sgrbshipping]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n</div>\r\n</div>\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-12\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n</div>\r\n</div>\r\n</div>','.sg-template-wrapper {\r\n	width: 100%;\r\n	height: 100%;\r\n	padding: 10px;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-image {\r\n	width: 100%;\r\n	overflow: hidden;\r\n	height: 390px;\r\n}\r\n\r\n.sg-tempo-title {\r\n	width: 100%;\r\n	height: 45px;\r\n	text-align: center;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	font-size: 1.1em;\r\n	font-weight: bold;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-by {\r\n	width: 100%;\r\n	height: 35px;\r\n	text-align: center;\r\n	padding: 5px;\r\n	color: #0066c0;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-price {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	text-align: center;\r\n	color: #D07D68;\r\n	font-size: 20px;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-shipping {\r\n	width: 100%;\r\n	text-align: center;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #000000;\r\n	font-size: 15px;\r\n	font-style: bold;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-title-second {\r\n	width: 100%;\r\n	text-align: center;\r\n	height: 35px;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-title-info {\r\n	width: 100%;\r\n	min-height: 34px;\r\n	text-align: center;\r\n	display: inline-block;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	line-height: 140%;\r\n	overflow: hidden;\r\n}\r\n\r\n\r\n.sgrb-icon-wrapper {\r\n	left: 40% !important;\r\n	top: 40% !important;\r\n}\r\n')";
		$insertQuery15 = "INSERT INTO $tablename VALUES (15,'opposite_corner_images',1,'".$path."template_10.jpeg','<div class=\"sg-template-wrapper\">\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-12\">\r\n<div class=\"sg-tempo-title\">[sgrbtitle]</div>\r\n</div>\r\n</div>\r\n<div class=\"sg-row sgrb-first-box\">\r\n<div class=\"sg-col-6\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n</div>\r\n<div class=\"sg-col-6\">\r\n<div class=\"sg-tempo-title-info sg-temp-field-full-height\">[sgrbshortdescription]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-by\">[sgrbproductby]</div>\r\n</div>\r\n</div>\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-6\">\r\n<div class=\"sg-tempo-title-info sg-temp-field-full-height\">[sgrbshortdescription]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-by\">[sgrbproductby]</div>\r\n</div>\r\n<div class=\"sg-col-6\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n</div>\r\n</div>\r\n</div>','.sg-template-wrapper {\r\n	width: 100%;\r\n	height: 100%;\r\n	padding: 10px;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sgrb-first-box {\r\n	margin-bottom:10px;\r\n}.sg-tempo-image {\r\n	max-width: 500px;\r\n	overflow: hidden;\r\n	height: 330px;\r\n}\r\n\r\n.sg-tempo-title {\r\n	width: 100%;\r\n	height: 45px;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	font-size: 1.1em;\r\n	font-weight: bold;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-by {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #0066c0;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-price {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #D07D68;\r\n	font-size: 20px;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-shipping {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #000000;\r\n	font-size: 15px;\r\n	font-style: bold;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-title-second {\r\n	width: 100%;\r\n	height: 35px;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-title-info {\r\n	width: 100%;\r\n	height: 180px;\r\n	display: inline-block;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	line-height: 140%;\r\n	overflow: hidden;\r\n}\r\n\r\n\r\n.sgrb-icon-wrapper {\r\n	left: 34% !important;\r\n	top: 40% !important;\r\n}\r\n')";
		$insertQuery24 = "INSERT INTO $tablename VALUES (24,'two_boxes',1,'".$path."two_boxes.jpeg','<div class=\"sg-template-wrapper\">\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-12\">\r\n<div class=\"sg-tempo-title\">[sgrbtitle]</div>\r\n</div>\r\n</div>\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-6\">\r\n<div class=\"sg-template-box\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrbsubtitle]</div>\r\n</div>\r\n</div>\r\n<div class=\"sg-col-6\">\r\n<div class=\"sg-template-box\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrbsubtitle]</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-12\">\r\n<div class=\"sg-template-box\">\r\n<div class=\"sg-tempo-context sg-temp-field-full-height\">[sgrblongdescription]</div>\r\n</div>\r\n</div>\r\n</div>\r\n</div>','.sg-template-wrapper {\r\n	width: 100%;\r\n	padding: 10px;\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-template-box {\r\n	display: inline-block;\r\n	min-height: 30px;\r\n	width: 100%;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-image {\r\n	width: 98%;\r\n	overflow: hidden;\r\n	height: 250px;\r\n}\r\n\r\n.sg-tempo-title {\r\n	width: 100%;\r\n	display: inline-block;\r\n	margin-bottom: 10px;\r\n	border: 1px solid rgb(223, 223, 223);\r\n	border-radius: 3px;\r\n	text-align: center;\r\n	font-size: 1.4em;\r\n	font-weight: bold;\r\n	background-color: #ffffff;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-title-second {\r\n	width: 100%;\r\n	height: 30px;\r\n	display: inline-block;\r\n	margin-top: 10px;\r\n	border: 1px solid rgb(223, 223, 223);\r\n	border-radius: 3px;\r\n	background-color: #ffffff;\r\n	box-sizing: border-box;\r\n	padding: 0 5px;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-context {\r\n	width: 100%;\r\n	min-height: 20px;\r\n	display: inline-block;\r\n	overflow: auto;\r\n	padding: 10px;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	background-color: #ffffff;\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sgrb-icon-wrapper {\r\n	left: 35% !important;\r\n	top: 35% !important;\r\n}\r\n')";
		$deleteRowsQuery = "INSERT INTO $tablename (`name`, `sgrb_pro_version`) VALUES ('simple_review', 1)";

		if (!SGRB_PRO_VERSION) {
			$insertQuery6 = "INSERT INTO $tablename VALUES (6,'left_image_one_link',0,'".$path."template_1.jpeg','','')";
			$insertQuery8 = "INSERT INTO $tablename VALUES (8,'twin_boxes',0,'".$path."template_3.jpeg','','')";
			$insertQuery9 = "INSERT INTO $tablename VALUES (9,'featured_images',0,'".$path."template_4.jpeg','','')";
			$insertQuery10 = "INSERT INTO $tablename VALUES (10,'right_image_double_link',0,'".$path."template_5.jpeg','','')";
			$insertQuery11 = "INSERT INTO $tablename VALUES (11,'four_box_mirror',0,'".$path."template_6.jpeg','','')";
			$insertQuery12 = "INSERT INTO $tablename VALUES (12,'corner_image_detailed',0,'".$path."template_7.jpeg','','')";
			$insertQuery14 = "INSERT INTO $tablename VALUES (14,'center_horizontal_image',0,'".$path."template_9.jpeg','','')";
			$insertQuery16 = "INSERT INTO $tablename VALUES (16,'opposite_corner_images_2',0,'".$path."template_11.jpeg','','')";
			$insertQuery17 = "INSERT INTO $tablename VALUES (17,'center_featured_images',0,'".$path."template_12.jpeg','','')";
			$insertQuery18 = "INSERT INTO $tablename VALUES (18,'center_featured_toggle_images',0,'".$path."template_13.jpeg','','')";
			$insertQuery19 = "INSERT INTO $tablename VALUES (19,'zigzag_ordered_images',0,'".$path."template_14.jpeg','','')";
			$insertQuery20 = "INSERT INTO $tablename VALUES (20,'zigzag_ordered_toggle_images',0,'".$path."template_15.jpeg','','')";
			$insertQuery21 = "INSERT INTO $tablename VALUES (21,'two_large_mirror_images',0,'".$path."template_16.jpeg','','')";
			$insertQuery22 = "INSERT INTO $tablename VALUES (22,'three_centered_boxes',0,'".$path."template_17.jpeg','','')";
			$insertQuery23 = "INSERT INTO $tablename VALUES (23,'three_top_bottom_boxes',0,'".$path."template_18.jpeg','','')";
		}
		else {
			$insertQuery6 = "INSERT INTO $tablename VALUES (6,'left_image_one_link',1,'".$path."template_1.jpeg','<div class=\"sg-template-wrapper\">\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-4\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n</div>\r\n<div class=\"sg-col-8\">\r\n<div class=\"sg-tempo-title\">[sgrbtitle]</div>\r\n<div class=\"sg-tempo-price\">[sgrbprice]</div>\r\n<div class=\"sg-tempo-shipping\">[sgrbshipping]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-title-info\">[sgrblongdescription]</div>\r\n<div class=\"sg-tempo-by\">[sgrbproductby]</div>\r\n</div>\r\n</div>\r\n</div>','.sg-template-wrapper {\r\n	width: 100%;\r\n	height: 100%;\r\n	padding: 10px;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-image {\r\n	max-width: 500px;\r\n	overflow: hidden;\r\n	height: 390px;\r\n}\r\n\r\n.sg-tempo-title {\r\n	width: 100%;\r\n	height: 45px;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	font-size: 1.1em;\r\n	font-weight: bold;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-by {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #0066c0;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-price {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #D07D68;\r\n	font-size: 20px;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-shipping {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #000000;\r\n	font-size: 15px;\r\n	font-style: bold;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-title-second {\r\n	width: 100%;\r\n	height: 35px;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-title-info {\r\n	width: 100%;\r\n	min-height: 34px;\r\n	display: inline-block;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	line-height: 140%;\r\n	overflow: hidden;\r\n}\r\n\r\n.sgrb-icon-wrapper {\r\n	left: 28% !important;\r\n	top: 40% !important;\r\n}\r\n')";
			$insertQuery8 = "INSERT INTO $tablename VALUES (8,'twin_boxes',1,'".$path."template_3.jpeg','<div class=\"sg-template-wrapper\">\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-12\">\r\n<div class=\"sg-tempo-title\">[sgrbtitle]</div>\r\n</div>\r\n</div>\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-6\">\r\n<div class=\"sg-template-box\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrbsubtitle]</div>\r\n<div class=\"sg-tempo-price\">[sgrbprice]</div>\r\n<div class=\"sg-tempo-shipping\">[sgrbshipping]</div>\r\n</div>\r\n</div>\r\n<div class=\"sg-col-6\">\r\n<div class=\"sg-template-box\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrbsubtitle]</div>\r\n<div class=\"sg-tempo-price\">[sgrbprice]</div>\r\n<div class=\"sg-tempo-shipping\">[sgrbshipping]</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-12\">\r\n<div class=\"sg-tempo-title-info\">[sgrbshortdescription]</div>\r\n</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n</div>\r\n</div>','.sg-template-wrapper {\r\n	width: 100%;\r\n	height: 100%;\r\n	padding: 10px;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-image {\r\n	max-width: 500px;\r\n	overflow: hidden;\r\n	height: 390px;\r\n}\r\n\r\n.sg-tempo-title {\r\n	width: 100%;\r\n	height: 45px;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	font-size: 1.1em;\r\n	font-weight: bold;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-by {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #0066c0;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-price {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #D07D68;\r\n	font-size: 20px;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-shipping {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #000000;\r\n	font-size: 15px;\r\n	font-style: bold;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-title-second {\r\n	width: 100%;\r\n	height: 35px;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-title-info {\r\n	width: 100%;\r\n	height: 140px;\r\n	display: inline-block;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	line-height: 116%;\r\n	overflow: hidden;\r\n}\r\n\r\n.sgrb-icon-wrapper {\r\n	left: 35% !important;\r\n	top: 40% !important;\r\n}\r\n')";
			$insertQuery9 = "INSERT INTO $tablename VALUES (9,'featured_images',1,'".$path."template_4.jpeg','<div class=\"sg-template-wrapper\">\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-12\">\r\n<div class=\"sg-tempo-title\">[sgrbtitle]</div>\r\n</div>\r\n</div>\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-12\">\r\n<div class=\"sg-tempo-main-image sg-tempo-image\">[sgrbimg]</div>\r\n</div>\r\n</div>\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-6\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrbsubtitle]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-price\">[sgrbprice]</div>\r\n</div>\r\n<div class=\"sg-col-6\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrbsubtitle]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-price\">[sgrbprice]</div>\r\n</div>\r\n</div>\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-12\">\r\n<div class=\"sg-tempo-title-info\">[sgrblongdescription]</div>\r\n</div>\r\n<div class=\"sg-tempo-by\">[sgrbproductby]</div>\r\n</div>\r\n</div>','.sg-template-wrapper {\r\n	width: 100%;\r\n	height: 100%;\r\n	padding: 10px;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-image {\r\n	/*max-width: 500px;*/\r\n	overflow: hidden;\r\n	height: 390px;\r\n}\r\n\r\n.sg-tempo-main-image {\r\n	width: 100% !important;\r\n	overflow: hidden;\r\n	margin: 30px auto;\r\n	height: 300px;\r\n}\r\n\r\n.sg-tempo-title {\r\n	text-align:center;\r\n	width: 100%;\r\n	height: 45px;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	font-size: 1.1em;\r\n	font-weight: bold;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-by {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #0066c0;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-price {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #D07D68;\r\n	font-size: 20px;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-shipping {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #000000;\r\n	font-size: 15px;\r\n	font-style: bold;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-title-second {\r\n	width: 100%;\r\n	height: 35px;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-title-info {\r\n	width: 100%;\r\n	min-height: 20px;\r\n	display: inline-block;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	line-height: 116%;\r\n	overflow: hidden;\r\n}\r\n\r\n\r\n.sgrb-icon-wrapper {\r\n	left: 35% !important;\r\n	top: 40% !important;\r\n}\r\n\r\n.sg-tempo-main-image .sgrb-icon-wrapper {\r\n	left: 42% !important;\r\n	top: 40% !important;\r\n}\r\n')";
			$insertQuery10 = "INSERT INTO $tablename VALUES (10,'right_image_double_link',1,'".$path."template_5.jpeg','<div class=\"sg-template-wrapper\">\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-8\">\r\n<div class=\"sg-tempo-title\">[sgrbtitle]</div>\r\n<div class=\"sg-tempo-by\">[sgrbproductby]</div>\r\n<div class=\"sg-tempo-price\">[sgrbprice]</div>\r\n<div class=\"sg-tempo-shipping\">[sgrbshipping]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-title-info\">[sgrblongdescription]</div>\r\n</div>\r\n<div class=\"sg-col-4\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n</div>\r\n</div>\r\n</div>','.sg-template-wrapper {\r\n	width: 100%;\r\n	height: 100%;\r\n	padding: 10px;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-image {\r\n	max-width: 500px;\r\n	overflow: hidden;\r\n	height: 390px;\r\n}\r\n\r\n.sg-tempo-title {\r\n	width: 100%;\r\n	height: 45px;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	font-size: 1.1em;\r\n	font-weight: bold;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-by {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #0066c0;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-price {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #D07D68;\r\n	font-size: 20px;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-shipping {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #000000;\r\n	font-size: 15px;\r\n	font-style: bold;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-title-second {\r\n	width: 100%;\r\n	height: 35px;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-title-info {\r\n	width: 100%;\r\n	min-height: 20px;\r\n	display: inline-block;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	line-height: 140%;\r\n	overflow: hidden;\r\n}\r\n\r\n.sgrb-icon-wrapper {\r\n	left: 26% !important;\r\n	top: 40% !important;\r\n}\r\n')";
			$insertQuery11 = "INSERT INTO $tablename VALUES (11,'four_box_mirror',1,'".$path."template_6.jpeg','<div class=\"sg-template-wrapper\">\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-6\">\r\n<div class=\"sg-template-box\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrbsubtitle]</div>\r\n<div class=\"sg-tempo-price\">[sgrbprice]</div>\r\n</div>\r\n</div>\r\n<div class=\"sg-col-6\">\r\n<div class=\"sg-template-box\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrbsubtitle]</div>\r\n<div class=\"sg-tempo-price\">[sgrbprice]</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-6\">\r\n<div class=\"sg-template-box\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrbsubtitle]</div>\r\n<div class=\"sg-tempo-price\">[sgrbprice]</div>\r\n</div>\r\n</div>\r\n<div class=\"sg-col-6\">\r\n<div class=\"sg-template-box\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrbsubtitle]</div>\r\n<div class=\"sg-tempo-price\">[sgrbprice]</div>\r\n</div>\r\n</div>\r\n</div>\r\n\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-12\">\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n</div>\r\n</div>\r\n</div>','.sg-template-wrapper {\r\n	width: 100%;\r\n	height: 100%;\r\n	padding: 10px;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-image {\r\n	max-width: 500px;\r\n	overflow: hidden;\r\n	height: 390px;\r\n}\r\n\r\n.sg-tempo-title {\r\n	width: 100%;\r\n	height: 45px;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	font-size: 1.1em;\r\n	font-weight: bold;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-by {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #0066c0;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-price {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #D07D68;\r\n	font-size: 20px;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-shipping {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #000000;\r\n	font-size: 15px;\r\n	font-style: bold;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-title-second {\r\n	width: 100%;\r\n	height: 35px;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-title-info {\r\n	width: 100%;\r\n	height: 140px;\r\n	display: inline-block;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	line-height: 116%;\r\n	overflow: hidden;\r\n}\r\n\r\n.sgrb-icon-wrapper {\r\n	left: 35% !important;\r\n	top: 40% !important;\r\n}')";
			$insertQuery12 = "INSERT INTO $tablename VALUES (12,'corner_image_detailed',1,'".$path."template_7.jpeg','<div class=\"sg-template-wrapper\">\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-4\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n</div>\r\n<div class=\"sg-col-8\">\r\n<div class=\"sg-tempo-title\">[sgrbtitle]</div>\r\n<div class=\"sg-tempo-title-info sg-temp-field-full-height\">[sgrblongdescription]</div>\r\n</div>\r\n</div>\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-12\">\r\n<div class=\"sg-tempo-by\">[sgrbproductby]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-price\">[sgrbprice]</div>\r\n<div class=\"sg-tempo-shipping\">[sgrbshipping]</div>\r\n</div>\r\n</div>\r\n</div>','.sg-template-wrapper {\r\n	width: 100%;\r\n	height: 100%;\r\n	padding: 10px;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-image {\r\n	max-width: 500px;\r\n	overflow: hidden;\r\n	height: 300px;\r\n}\r\n\r\n.sg-tempo-title {\r\n	width: 100%;\r\n	height: 45px;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	font-size: 1.1em;\r\n	font-weight: bold;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-by {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #0066c0;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-price {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #D07D68;\r\n	font-size: 20px;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-shipping {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #000000;\r\n	font-size: 15px;\r\n	font-style: bold;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-title-second {\r\n	width: 100%;\r\n	height: 35px;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-title-info {\r\n	width: 100%;\r\n	height: 200px;\r\n	display: inline-block;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	line-height: 140%;\r\n	overflow: hidden;\r\n}\r\n\r\n.sgrb-icon-wrapper {\r\n	left: 26% !important;\r\n	top: 40% !important;\r\n}')";
			$insertQuery14 = "INSERT INTO $tablename VALUES (14,'center_horizontal_image',1,'".$path."template_9.jpeg','<div class=\"sg-template-wrapper\">\n<div class=\"sg-row\">\n<div class=\"sg-col-12\">\n<div class=\"sg-tempo-title\">\n[sgrbtitle]\n</div>\n<div class=\"sg-tempo-title-info\">\n[sgrbshortdescription]\n</div>\n</div>\n</div>\n<div class=\"sg-row\">\n<div class=\"sg-col-12\">\n<div class=\"sg-tempo-image\">\n[sgrbimg]\n</div>\n</div>\n</div>\n<div class=\"sg-row\">\n<div class=\"sg-col-12\">\n\n<div class=\"sg-tempo-price\">\n[sgrbprice]\n</div>\n<div class=\"sg-tempo-shipping\">\n[sgrbshipping]\n</div>\n<div class=\"sg-tempo-title-second\">\n[sgrblink]\n</div>\n<div class=\"sg-tempo-title-second\">\n[sgrblink]\n</div>\n<div class=\"sg-tempo-by\">\n[sgrbproductby]\n</div>\n</div>\n</div>\n</div>','.sg-template-wrapper {\n	width: 100%;\n	height: 100%;\n	padding: 10px;\n	border: 1px solid rgb(250, 250, 250);\n	box-sizing: border-box;\n}\n\n.sg-tempo-image {\n	width: 100%;\n	overflow: hidden;\n	height: 390px;\n}\n\n.sg-tempo-title {\n	width: 100%;\n	height: 45px;\n	display: inline-block;\n	border-radius: 3px;\n	font-size: 1.1em;\n	font-weight: bold;\n	background-color: white;\n	box-sizing: border-box;\n	padding: 5px;\n	overflow: hidden;\n	line-height: 100%;\n}\n\n.sg-tempo-by {\n	width: 100%;\n	height: 35px;\n	padding: 5px;\n	color: #0066c0;\n	display: inline-block;\n	box-sizing: border-box;\n}\n\n.sg-tempo-price {\n	width: 100%;\n	height: 35px;\n	padding: 5px;\n	color: #D07D68;\n	font-size: 20px;\n	display: inline-block;\n	box-sizing: border-box;\n	overflow: hidden;\n}\n\n.sg-tempo-shipping {\n	width: 100%;\n	height: 35px;\n	padding: 5px;\n	color: #000000;\n	font-size: 15px;\n	font-style: bold;\n	display: inline-block;\n	box-sizing: border-box;\n	overflow: hidden;\n}\n\n.sg-tempo-title-second {\n	width: 100%;\n	height: 35px;\n	display: inline-block;\n	border-radius: 3px;\n	background-color: white;\n	box-sizing: border-box;\n	padding: 5px;\n	overflow: hidden;\n	line-height: 100%;\n}\n\n.sg-tempo-title-info {\n	width: 100%;\n	min-height: 20px;\n	display: inline-block;\n	border: 1px solid rgb(250, 250, 250);\n	border-radius: 3px;\n	background-color: white;\n	box-sizing: border-box;\n	padding: 5px;\n	line-height: 140%;\n	overflow: hidden;\n}\n\n\n.sgrb-icon-wrapper {\n	left: 40% !important;\n	top: 40% !important;\n}\n')";
			$insertQuery16 = "INSERT INTO $tablename VALUES (16,'opposite_corner_images_2',1,'".$path."template_11.jpeg','<div class=\"sg-template-wrapper\">\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-12\">\r\n<div class=\"sg-tempo-title\">[sgrbtitle]</div>\r\n</div>\r\n</div>\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-6\">\r\n<div class=\"sg-tempo-title-info sg-temp-field-full-height\">[sgrbshortdescription]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-by\">[sgrbproductby]</div>\r\n</div>\r\n<div class=\"sg-col-6\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n</div>\r\n</div>\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-6\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n</div>\r\n<div class=\"sg-col-6\">\r\n<div class=\"sg-tempo-title-info sg-temp-field-full-height\">[sgrbshortdescription]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n			<div class=\"sg-tempo-by\">[sgrbproductby]</div>\r\n</div>\r\n</div>\r\n</div>','.sg-template-wrapper {\r\n	width: 100%;\r\n	height: 100%;\r\n	padding: 10px;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-image {\r\n	max-width: 500px;\r\n	overflow: hidden;\r\n	height: 330px;\r\n}\r\n\r\n.sg-tempo-title {\r\n	width: 100%;\r\n	height: 45px;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	font-size: 1.1em;\r\n	font-weight: bold;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-by {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #0066c0;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-price {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #D07D68;\r\n	font-size: 20px;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-shipping {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #000000;\r\n	font-size: 15px;\r\n	font-style: bold;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-title-second {\r\n	width: 100%;\r\n	height: 35px;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-title-info {\r\n	width: 100%;\r\n	height: 180px;\r\n	display: inline-block;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	line-height: 140%;\r\n	overflow: hidden;\r\n}\r\n\r\n\r\n.sgrb-icon-wrapper {\r\n	left: 34% !important;\r\n	top: 40% !important;\r\n}\r\n')";
			$insertQuery17 = "INSERT INTO $tablename VALUES (17,'center_featured_images',1,'".$path."template_12.jpeg','<div class=\"sg-template-wrapper\">\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-12\">\r\n<div class=\"sg-tempo-title\">[sgrbtitle]</div>\r\n<div class=\"sg-tempo-title-info\">[sgrbshortdescription]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-by\">[sgrbproductby]</div>\r\n</div>\r\n</div>\r\n	<div class=\"sg-row\">\r\n<div class=\"sg-col-4\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n</div>\r\n<div class=\"sg-col-4\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n</div>\r\n<div class=\"sg-col-4\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n</div>\r\n	</div>\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-12\">\r\n<div class=\"sg-tempo-main-image sg-tempo-image\">[sgrbimg]</div>\r\n</div>\r\n</div>\r\n</div>','.sg-template-wrapper {\r\n	width: 100%;\r\n	height: 100%;\r\n	padding: 10px;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-image {\r\n	/*max-width: 500px;*/\r\n	overflow: hidden;\r\n	height: 390px;\r\n}\r\n\r\n.sg-tempo-main-image {\r\n	width: 100% !important;\r\n	overflow: hidden;\r\n	margin: 30px auto;\r\n	height: 300px;\r\n}\r\n\r\n.sg-tempo-title {\r\n	width: 100%;\r\n	height: 45px;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	font-size: 1.1em;\r\n	font-weight: bold;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-by {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #0066c0;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-price {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #D07D68;\r\n	font-size: 20px;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-shipping {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #000000;\r\n	font-size: 15px;\r\n	font-style: bold;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-title-second {\r\n	width: 100%;\r\n	height: 35px;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-title-info {\r\n	width: 100%;\r\n	min-height: 34px;\r\n	display: inline-block;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	line-height: 140%;\r\n	overflow: hidden;\r\n}\r\n\r\n\r\n.sgrb-icon-wrapper {\r\n	left: 26% !important;\r\n	top: 40% !important;\r\n}\r\n\r\n.sg-tempo-main-image .sgrb-icon-wrapper {\r\n	left: 40% !important;\r\n	top: 40% !important;\r\n}\r\n')";
			$insertQuery18 = "INSERT INTO $tablename VALUES (18,'center_featured_toggle_images',1,'".$path."template_13.jpeg','<div class=\"sg-template-wrapper\">\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-4\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n</div>\r\n<div class=\"sg-col-4\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n</div>\r\n<div class=\"sg-col-4\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n</div>\r\n	</div>\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-12\">\r\n<div class=\"sg-tempo-main-image sg-tempo-image\">[sgrbimg]</div>\r\n</div>\r\n</div>\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-12\">\r\n<div class=\"sg-tempo-title\">[sgrbtitle]</div>\r\n<div class=\"sg-tempo-title-info\">[sgrbshortdescription]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-by\">[sgrbproductby]</div>\r\n</div>\r\n</div>\r\n\r\n</div>','.sg-template-wrapper {\r\n	width: 100%;\r\n	height: 100%;\r\n	padding: 10px;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-image {\r\n	/*max-width: 500px;*/\r\n	overflow: hidden;\r\n	height: 390px;\r\n}\r\n\r\n.sg-tempo-main-image {\r\n	width: 100% !important;\r\n	overflow: hidden;\r\n	margin: 30px auto;\r\n	height: 300px;\r\n}\r\n\r\n.sg-tempo-title {\r\n	width: 100%;\r\n	height: 45px;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	font-size: 1.1em;\r\n	font-weight: bold;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-by {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #0066c0;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-price {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #D07D68;\r\n	font-size: 20px;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-shipping {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #000000;\r\n	font-size: 15px;\r\n	font-style: bold;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-title-second {\r\n	width: 100%;\r\n	height: 35px;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-title-info {\r\n	width: 100%;\r\n	min-height: 34px;\r\n	display: inline-block;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	line-height: 140%;\r\n	overflow: hidden;\r\n}\r\n\r\n.sgrb-icon-wrapper {\r\n	left: 26% !important;\r\n	top: 40% !important;\r\n}\r\n\r\n.sg-tempo-main-image .sgrb-icon-wrapper {\r\n	left: 40% !important;\r\n	top: 40% !important;\r\n}\r\n')";
			$insertQuery19 = "INSERT INTO $tablename VALUES (19,'zigzag_ordered_images',1,'".$path."template_14.jpeg','<div class=\"sg-template-wrapper\">\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-4\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n</div>\r\n<div class=\"sg-col-8\">\r\n<div class=\"sg-tempo-title\">[sgrbtitle]</div>\r\n<div class=\"sg-tempo-price\">[sgrbprice]</div>\r\n<div class=\"sg-tempo-shipping\">[sgrbshipping]</div>\r\n<div class=\"sg-tempo-by\">[sgrbproductby]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n</div>\r\n</div>\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-8\">\r\n<div class=\"sg-tempo-title\">[sgrbtitle]</div>\r\n<div class=\"sg-tempo-price\">[sgrbprice]</div>\r\n<div class=\"sg-tempo-shipping\">[sgrbshipping]</div>\r\n<div class=\"sg-tempo-by\">[sgrbproductby]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n</div>\r\n<div class=\"sg-col-4\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n</div>\r\n</div>\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-4\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n</div>\r\n<div class=\"sg-col-8\">\r\n<div class=\"sg-tempo-title\">[sgrbtitle]</div>\r\n<div class=\"sg-tempo-price\">[sgrbprice]</div>\r\n<div class=\"sg-tempo-shipping\">[sgrbshipping]</div>\r\n<div class=\"sg-tempo-by\">[sgrbproductby]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n</div>\r\n</div>\r\n</div>','.sg-template-wrapper {\r\n	width: 100%;\r\n	height: 100%;\r\n	padding: 10px;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-image {\r\n	max-width: 500px;\r\n	overflow: hidden;\r\n	height: 250px;\r\n}\r\n\r\n.sg-tempo-title {\r\n	width: 100%;\r\n	height: 45px;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	font-size: 1.1em;\r\n	font-weight: bold;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-by {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #0066c0;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-price {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #D07D68;\r\n	font-size: 20px;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-shipping {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #000000;\r\n	font-size: 15px;\r\n	font-style: bold;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-title-second {\r\n	width: 100%;\r\n	height: 35px;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-title-info {\r\n	width: 100%;\r\n	min-height: 34px;\r\n	display: inline-block;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	line-height: 140%;\r\n	overflow: hidden;\r\n}\r\n\r\n.sgrb-icon-wrapper {\r\n	left: 26% !important;\r\n	top: 40% !important;\r\n}')";
			$insertQuery20 = "INSERT INTO $tablename VALUES (20,'zigzag_ordered_toggle_images',1,'".$path."template_15.jpeg','<div class=\"sg-template-wrapper\">\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-8\">\r\n<div class=\"sg-tempo-title\">[sgrbtitle]</div>\r\n<div class=\"sg-tempo-price\">[sgrbprice]</div>\r\n<div class=\"sg-tempo-shipping\">[sgrbshipping]</div>\r\n<div class=\"sg-tempo-by\">[sgrbproductby]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n</div>\r\n<div class=\"sg-col-4\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n</div>\r\n</div>\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-4\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n</div>\r\n<div class=\"sg-col-8\">\r\n<div class=\"sg-tempo-title\">[sgrbtitle]</div>\r\n<div class=\"sg-tempo-price\">[sgrbprice]</div>\r\n<div class=\"sg-tempo-shipping\">[sgrbshipping]</div>\r\n<div class=\"sg-tempo-by\">[sgrbproductby]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n</div>\r\n</div>\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-8\">\r\n<div class=\"sg-tempo-title\">[sgrbtitle]</div>\r\n<div class=\"sg-tempo-price\">[sgrbprice]</div>\r\n<div class=\"sg-tempo-shipping\">[sgrbshipping]</div>\r\n<div class=\"sg-tempo-by\">[sgrbproductby]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n</div>\r\n<div class=\"sg-col-4\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n</div>\r\n</div>\r\n</div>','.sg-template-wrapper {\r\n	width: 100%;\r\n	height: 100%;\r\n	padding: 10px;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-image {\r\n	max-width: 500px;\r\n	overflow: hidden;\r\n	height: 250px;\r\n}\r\n\r\n.sg-tempo-title {\r\n	width: 100%;\r\n	height: 45px;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	font-size: 1.1em;\r\n	font-weight: bold;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-by {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #0066c0;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-price {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #D07D68;\r\n	font-size: 20px;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-shipping {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #000000;\r\n	font-size: 15px;\r\n	font-style: bold;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-title-second {\r\n	width: 100%;\r\n	height: 35px;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-title-info {\r\n	width: 100%;\r\n	min-height: 34px;\r\n	display: inline-block;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	line-height: 140%;\r\n	overflow: hidden;\r\n}\r\n\r\n.sgrb-icon-wrapper {\r\n	left: 26% !important;\r\n	top: 40% !important;\r\n}')";
			$insertQuery21 = "INSERT INTO $tablename VALUES (21,'two_large_mirror_images',1,'".$path."template_16.jpeg','<div class=\"sg-template-wrapper\">\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-6\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n<div class=\"sg-tempo-by\">[sgrbproductby]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n</div>\r\n<div class=\"sg-col-6\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n<div class=\"sg-tempo-by\">[sgrbproductby]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n</div>\r\n</div>\r\n</div>','.sg-template-wrapper {\r\n	width: 100%;\r\n	height: 100%;\r\n	padding: 10px;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-image {\r\n	max-width: 500px;\r\n	overflow: hidden;\r\n	height: 390px;\r\n}\r\n\r\n.sg-tempo-title {\r\n	width: 100%;\r\n	height: 45px;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	font-size: 1.1em;\r\n	font-weight: bold;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-by {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #0066c0;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-price {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #D07D68;\r\n	font-size: 20px;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-shipping {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #000000;\r\n	font-size: 15px;\r\n	font-style: bold;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-title-second {\r\n	width: 100%;\r\n	height: 35px;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-title-info {\r\n	width: 100%;\r\n	min-height: 34px;\r\n	display: inline-block;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	line-height: 140%;\r\n	overflow: hidden;\r\n}\r\n\r\n.sgrb-icon-wrapper {\r\n	left: 35% !important;\r\n	top: 40% !important;\r\n}')";
			$insertQuery22 = "INSERT INTO $tablename VALUES (22,'three_centered_boxes',1,'".$path."template_17.jpeg','<div class=\"sg-template-wrapper\">\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-12\">\r\n<div class=\"sg-tempo-title-info\">[sgrblongdescription]</div>\r\n</div>\r\n</div>\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-4\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n<div class=\"sg-tempo-subtitle\">[sgrbsubtitle]</div>\r\n<div class=\"sg-tempo-price\">[sgrbprice]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-by\">[sgrbproductby]</div>\r\n</div>\r\n<div class=\"sg-col-4\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n<div class=\"sg-tempo-subtitle\">[sgrbsubtitle]</div>\r\n<div class=\"sg-tempo-price\">[sgrbprice]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-by\">[sgrbproductby]</div>\r\n</div>\r\n<div class=\"sg-col-4\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n<div class=\"sg-tempo-subtitle\">[sgrbsubtitle]</div>\r\n<div class=\"sg-tempo-price\">[sgrbprice]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-by\">[sgrbproductby]</div>\r\n</div>\r\n</div>\r\n\r\n</div>','.sg-template-wrapper {\r\n	width: 100%;\r\n	height: 100%;\r\n	padding: 10px;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-image {\r\n	max-width: 500px;\r\n	overflow: hidden;\r\n	height: 250px;\r\n}\r\n\r\n.sg-tempo-title {\r\n	width: 100%;\r\n	height: 45px;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	font-size: 1.1em;\r\n	font-weight: bold;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-subtitle {\r\n	width: 100%;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	font-size: 1.1em;\r\n	font-weight: bold;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-by {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #0066c0;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-price {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #D07D68;\r\n	font-size: 20px;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-shipping {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #000000;\r\n	font-size: 15px;\r\n	font-style: bold;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-title-second {\r\n	width: 100%;\r\n	height: 35px;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-title-info {\r\n	width: 100%;\r\n	min-height: 20px;\r\n	display: inline-block;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	line-height: 140%;\r\n	overflow: hidden;\r\n}\r\n\r\n.sgrb-icon-wrapper {\r\n	left: 26% !important;\r\n	top: 40% !important;\r\n}')";
			$insertQuery23 = "INSERT INTO $tablename VALUES (23,'three_top_bottom_boxes',1,'".$path."template_18.jpeg','<div class=\"sg-template-wrapper\">\r\n<div class=\"sg-row\">\r\n<div class=\"sg-col-4\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n<div class=\"sg-tempo-subtitle\">[sgrbsubtitle]</div>\r\n<div class=\"sg-tempo-price\">[sgrbprice]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-shipping\">[sgrbshipping]</div>\r\n<div class=\"sg-tempo-by\">[sgrbproductby]</div>\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n</div>\r\n<div class=\"sg-col-4\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n<div class=\"sg-tempo-subtitle\">[sgrbsubtitle]</div>\r\n<div class=\"sg-tempo-price\">[sgrbprice]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-shipping\">[sgrbshipping]</div>\r\n<div class=\"sg-tempo-by\">[sgrbproductby]</div>\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n</div>\r\n<div class=\"sg-col-4\">\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n<div class=\"sg-tempo-subtitle\">[sgrbsubtitle]</div>\r\n<div class=\"sg-tempo-price\">[sgrbprice]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-title-second\">[sgrblink]</div>\r\n<div class=\"sg-tempo-shipping\">[sgrbshipping]</div>\r\n<div class=\"sg-tempo-by\">[sgrbproductby]</div>\r\n<div class=\"sg-tempo-image\">[sgrbimg]</div>\r\n</div>\r\n</div>\r\n\r\n</div>','.sg-template-wrapper {\r\n	width: 100%;\r\n	height: 100%;\r\n	padding: 10px;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-image {\r\n	max-width: 500px;\r\n	overflow: hidden;\r\n	height: 250px;\r\n}\r\n\r\n.sg-tempo-title {\r\n	width: 100%;\r\n	height: 45px;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	font-size: 1.1em;\r\n	font-weight: bold;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-subtitle {\r\n	width: 100%;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	font-size: 1.1em;\r\n	font-weight: bold;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-by {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #0066c0;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n}\r\n\r\n.sg-tempo-price {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #D07D68;\r\n	font-size: 20px;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-shipping {\r\n	width: 100%;\r\n	height: 35px;\r\n	padding: 5px;\r\n	color: #000000;\r\n	font-size: 15px;\r\n	font-style: bold;\r\n	display: inline-block;\r\n	box-sizing: border-box;\r\n	overflow: hidden;\r\n}\r\n\r\n.sg-tempo-title-second {\r\n	width: 100%;\r\n	height: 35px;\r\n	display: inline-block;\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	overflow: hidden;\r\n	line-height: 100%;\r\n}\r\n\r\n.sg-tempo-title-info {\r\n	width: 100%;\r\n	min-height: 34px;\r\n	display: inline-block;\r\n	border: 1px solid rgb(250, 250, 250);\r\n	border-radius: 3px;\r\n	background-color: white;\r\n	box-sizing: border-box;\r\n	padding: 5px;\r\n	line-height: 140%;\r\n	overflow: hidden;\r\n}\r\n\r\n.sgrb-icon-wrapper {\r\n	left: 29% !important;\r\n	top: 35% !important;\r\n}\r\n')";
			$insertQuery25 = "INSERT INTO $tablename (`name`, `sgrb_pro_version`) VALUES ('simple_review', 1)";
		}

		if (!$saveTemplates) {
			$wpdb->query($insertQuery1);
			$wpdb->query($insertQuery2);
			$wpdb->query($insertQuery3);
			$wpdb->query($insertQuery4);
			$wpdb->query($insertQuery5);
			$wpdb->query($insertQuery6);
			$wpdb->query($insertQuery7);
			$wpdb->query($insertQuery8);
			$wpdb->query($insertQuery9);
			$wpdb->query($insertQuery10);
			$wpdb->query($insertQuery11);
			$wpdb->query($insertQuery12);
			$wpdb->query($insertQuery13);
			$wpdb->query($insertQuery14);
			$wpdb->query($insertQuery15);
			$wpdb->query($insertQuery16);
			$wpdb->query($insertQuery17);
			$wpdb->query($insertQuery18);
			$wpdb->query($insertQuery19);
			$wpdb->query($insertQuery20);
			$wpdb->query($insertQuery21);
			$wpdb->query($insertQuery22);
			$wpdb->query($insertQuery23);
			$wpdb->query($insertQuery24);
			$wpdb->query($deleteRowsQuery);
		}
	}

	public static function updateColumns($blogId = '')
	{
		global $sgrb;
		global $wpdb;
		$tablename = $sgrb->tablename(self::TABLE, $blogId);
		$sgrbVersion = get_option('SGRB_VERSION');

		$query = "DELETE FROM $tablename WHERE `id` = 25";
		$query2 = "DELETE FROM $tablename WHERE `id` = 26";

		$wpdb->query($query);
		$wpdb->query($query2);
	}

	public static function drop($blogId = '')
	{
		global $sgrb;
		global $wpdb;
		$tablename = $sgrb->tablename(self::TABLE, $blogId);
		$query = "DROP TABLE $tablename";
		$wpdb->query($query);
	}
}
